<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
        <el-row :gutter="20">
        <!-- Filtros --> 
          <el-col :span="18" class="text-end">
            <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
          </el-col>
          <el-col :span="6">
            <el-input 
              v-if="filterSelect == allFilters[1].value || filterSelect == ''"
              class="input-head"
              placeholder="Buscar"
              prefix-icon="el-icon-search"
              :disabled="filterSelect==''"
              @keyup.enter.native="filterRegister"
              v-model="textSearch">
            </el-input>
            <app-select 
              class="select-state" 
              @changeValue="filterRegister" 
              v-else v-model="stateSelect" 
              :filterArray="statesDescriptions"></app-select>
          </el-col>  
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 7rem">
      <Title Title="PEDIDOS REALIZADOS"> </Title>
    </div>

    <!-- CUADRADITOS DE INFORMACION DEL ESTADO DE LOS PEDIDOS -->
    <div style="margin:2.5rem 10rem 3rem">
      <el-row :gutter="20">
        <el-col :span="8" style="margin-bottom: 10px;" v-for="item in statesDescriptions" :key="item.color">
          <div class="flex element-bloq-center" > 
            <div class="border-radius-light" :class="item.color" style="margin-right:1rem; height:25px; width:25px"></div> 
            <span> {{ item.label }} </span>
          </div>
        </el-col>
     </el-row>
    </div>
    <div class="text-end" style="margin: 0 14rem 1rem">
      <el-button @click="newOrder('NUEVOPEDIDO')" type="primary">NUEVO PEDIDO</el-button>
    </div>
    <!-- Tarjeta 'No hay resultado' -->
      <el-row v-bind:class="[ registerSupport.length == 0 ? 'remove-grid-container' : 'grid-container' ]" v-if="registerSupport.length == 0" >
        <el-col :span="20" :offset="2">
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-col :span="8" style="margin-top: 1rem" class="text-center">
              <img src="@/assets/images/detective.svg" alt="">
            </el-col>
            <el-col :span="16">
              <div style="margin-top: 5rem">
                <p class="title-styles">¡Lo sentimos!</p>
                <br>
                <p class="title-styles">{{textContentComputed}}</p>
              </div>
            </el-col>
          </el-card>
        </el-col>
      </el-row>
    <el-row style="margin:0 0 0 13rem" v-else>
      <el-col :span="19" v-for="item in registerSupport" :key="item._id" style="margin:0.5rem 0">
         <el-card :body-style="{ padding: '2.5rem 3rem 1rem'}">
          <el-row style="margin-bottom: 1rem ">
            <el-col :span="17">
              <el-button  
                @click="btnEventStateOrder( item )" 
                size="medium" class="bolt-light" 
                :type="item.stateOrder=='PENDIENTE'? 'info':item.stateOrder=='COMPLETO'? 'success':'danger'"> {{item.stateOrder}} </el-button> 
            </el-col>           
            <el-col :span="7" class="text-end">
              <img v-if="item.stateOrder == 'PENDIENTE'" @click="EditCards( item )" src="../../../assets/images/edit.svg"  alt="edit" width="33" style="display: inline">
              <img  @click="deleteItem( item )" src="../../../assets/images/basura-2.svg" alt="basura" width="33" style="margin-left: 1rem">
            </el-col>
          </el-row>
          <el-row style="margin: 5rem 0 3rem 0" >
            <el-col :span="10" class="bg-gray" style="padding: 8px">
              <span class="text-orange text-bold">N° DE PEDIDO:</span>
              <span style="margin-left:1rem" class="text-bold"> {{ item.numberOrder}} </span>
            </el-col>
          </el-row>    
          <el-row style="margin-bottom: 1rem">
            <el-col :span="12">
              <p style="margin-bottom: 1rem">
                <span class="fonts-bold-general" style="margin-right:1rem">Fecha de Pedido:</span><span > {{ item.dateOfOrder }} </span>
              </p>
              <p style="margin-bottom: 1rem">
                <span class="fonts-bold-general" style="margin-right:1rem">Soporte de Pedido:</span><span > {{ item.orderSupport }} </span>
              </p>
            </el-col>
            <el-col :span="12">
              <p style="margin-bottom: 1rem">
                <span class="fonts-bold-general" style="margin-right:1rem">N° de Discos Pedidos:</span><span > {{ item.quantity }} </span>
              </p>
              <p style="margin-bottom: 1rem">
                <span class="fonts-bold-general" style="margin-right:1rem">N° de Discos Pendientes:</span><span > {{ item.pendientes }}  </span>
              </p>
            </el-col>
            <el-col :span="24">
              <p style="margin-bottom: 1rem">
                <span class="fonts-bold-general" style="margin-right:1rem">Correlativos:</span><span> Desde {{item.codByOrder[0]}} hasta {{item.codByOrder[item.codByOrder.length - 1]}}</span>
              </p>
            </el-col>
          </el-row>
          <!-- modal eliminar-->
            <AppModal :show-dialog.sync="modalCancel"   v-if="modalCancel" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
              :parrafo="'¿Seguro de que quieres eliminar el pedido ingresado?'"
              classBtn1="border-red" typeBtn1="danger" btn1="SÍ,ELIMINAR" btn2="CANCELAR"  
              @btnEvent="deleteButton" @eventBtn="modalCancel = false">
            </AppModal>
        </el-card>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import CardSuport from '@/components/CardSuport.vue'
import Title from '@/components/Title.vue'  
import { HTTP } from '../../../main.js'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'

export default {
  components: {
    ReturnButton,
    CardSuport,
    Title,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    AppModal
  },
  created() {
    this.getOrdersSuport()
  },
  data() {
    return {
      returnButtonModal: false,
      textSearch: '',
      filterSelect: '',
      stateSelect: '',
      allFilters: [
        {value: 'stateOrder', label: 'Estado de la Orden'},
        {value: 'numberOrder', label: 'N° de Pedido'}
      ],
      statesDescriptions:[
        {label:'Pedido pendiente de llegada',color:'l-grey',value:'PENDIENTE'},
        {label:'Recepcion incompleta',color:'bg-red',value:'INCOMPLETO'},
        {label:'Recepcion completa',color:'l-green',value:'COMPLETO'}
      ],
      registerSupport: [],
      totalRegisterSupport: [],
      modalCancel:false,
      idSupport:null,
      // searchItem: false,
      textContent: 'No existen pedidos realizados'
    }
  },
  methods: {
    utilFormatDate(stringDate){
      return new Date(stringDate).toLocaleString("en-GB",{day:'numeric',month:'numeric',year:'numeric'})
    },
    deleteItem (item) { 
      this.idSupport = item._id;
      this.modalCancel= true
    },
    deleteButton (){
      HTTP.delete('supports/' + this.idSupport)
      .then(res => {this.modalCancel = false;this.getOrdersSuport()} )
      .catch(err => console.log(err))
    },
    EditCards ( item ) {      
      console.log(item);
      localStorage.setItem('objEditSupport',JSON.stringify(item));
      this.$router.push({name:'supportNewOrder'});     
    },
    newOrder () {
      localStorage.removeItem('objEditSupport');
      this.$router.push({ name: 'supportNewOrder' })
    },
    btnEventStateOrder ( item ) {
      localStorage.setItem('objEditSupport',JSON.stringify(item)); 
      this.$router.push({ name: 'receptionRecord' })
    },
    returnPage () {
      this.$router.push({ name: 'recordOfDiscs' })
    },
    getOrdersSuport () {
      HTTP.get('supports')
      .then(res => {
        const registros = res.data;
        registros.forEach(el=>{
          let count = 0;
          el.recived.forEach(element=>count+=parseInt(element.receivedDiscs));
          el.pendientes = el.quantity - count;
          el.dateOfOrder = this.utilFormatDate(el.dateOfOrder);
        })
        this.totalRegisterSupport = res.data
        this.registerSupport = res.data
      })
      .catch(err => {
        console.log(err)
        })
    },
    filterRegister(){
      this.textContent = 'No encontramos resultados para tu búsqueda'
      let numberOrder = this.textSearch;
      let stateOrder = null;
      if(this.filterSelect==this.allFilters[0].value){
        numberOrder = null ; stateOrder = this.stateSelect;
      }
      HTTP.post('supports/filter',{numberOrder,stateOrder})
      .then(res=>{ 
        const registros = res.data;
        registros.forEach(el=>{
          let count = 0;
          el.recived.forEach(element=>count+=parseInt(element.receivedDiscs));
          el.pendientes = el.quantity - count;
          el.dateOfOrder = this.utilFormatDate(el.dateOfOrder);
        })
        this.registerSupport = res.data
      })
      .catch(err =>{console.log(err, 'error')})
      console.log(this.registerSupport, 'registerSupport')
    } 
  },
  watch:{
    filterSelect(){
      if(this.filterSelect=='') {this.getOrdersSuport();this.textSearch=''}
    },
    registerSupport(val) {
      if(this.totalRegisterSupport.length == 0) {
        this.textContent = 'No existen pedidos realizados'
      }
    }
  },
  computed: {
    textContentComputed() {
      return this.textContent
    }
  }
}
</script>
<style>
.select-state .el-select{width: 100%;}
</style>
